Index: pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 6096)
+++ pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 6097)
@@ -511,10 +511,10 @@
 {
     /**
-     * The media stream, read-only.
+     * The audio media stream, read-only.
      */
     pjmedia_stream 	*stream;
 
     /**
-     * Stream index in the media session, read-only.
+     * Stream index in the audio media session, read-only.
      */
     unsigned 		 stream_idx;
@@ -531,5 +531,5 @@
 
     /**
-     * On input, it specifies the media port of the stream. Application
+     * On input, it specifies the audio media port of the stream. Application
      * may modify this pointer to point to different media port to be
      * registered to the conference bridge.
@@ -961,8 +961,8 @@
 
     /**
-     * Notify application when media session is created and before it is
+     * Notify application when audio media session is created and before it is
      * registered to the conference bridge. Application may return different
-     * media port if it has added media processing port to the stream. This
-     * media port then will be added to the conference bridge instead.
+     * audio media port if it has added media processing port to the stream.
+     * This media port then will be added to the conference bridge instead.
      *
      * Note: if implemented, #on_stream_created2() callback will be called
@@ -970,7 +970,7 @@
      *
      * @param call_id	    Call identification.
-     * @param strm	    Media stream.
-     * @param stream_idx    Stream index in the media session.
-     * @param p_port	    On input, it specifies the media port of the
+     * @param strm	    Audio media stream.
+     * @param stream_idx    Stream index in the audio media session.
+     * @param p_port	    On input, it specifies the audio media port of the
      *			    stream. Application may modify this pointer to
      *			    point to different media port to be registered
@@ -983,8 +983,8 @@
 
     /**
-     * Notify application when media session is created and before it is
+     * Notify application when audio media session is created and before it is
      * registered to the conference bridge. Application may return different
-     * media port if it has added media processing port to the stream. This
-     * media port then will be added to the conference bridge instead.
+     * audio media port if it has added media processing port to the stream.
+     * This media port then will be added to the conference bridge instead.
      *
      * @param call_id	    Call identification.
@@ -995,10 +995,10 @@
 
     /**
-     * Notify application when media session has been unregistered from the
-     * conference bridge and about to be destroyed.
+     * Notify application when audio media session has been unregistered from
+     * the conference bridge and about to be destroyed.
      *
      * @param call_id	    Call identification.
-     * @param strm	    Media stream.
-     * @param stream_idx    Stream index in the media session.
+     * @param strm	    Audio media stream.
+     * @param stream_idx    Stream index in the audio media session.
      */
     void (*on_stream_destroyed)(pjsua_call_id call_id,
Index: pjproject/trunk/pjsip/include/pjsua2/call.hpp
===================================================================
--- pjproject/trunk/pjsip/include/pjsua2/call.hpp	(revision 6096)
+++ pjproject/trunk/pjsip/include/pjsua2/call.hpp	(revision 6097)
@@ -679,10 +679,10 @@
 {
     /**
-     * Media stream, read-only.
+     * Audio media stream, read-only.
      */
     MediaStream stream;
     
     /**
-     * Stream index in the media session, read-only.
+     * Stream index in the audio media session, read-only.
      */
     unsigned    streamIdx;
@@ -699,5 +699,5 @@
 
     /**
-     * On input, it specifies the media port of the stream. Application
+     * On input, it specifies the audio media port of the stream. Application
      * may modify this pointer to point to different media port to be
      * registered to the conference bridge.
@@ -713,10 +713,10 @@
 {
     /**
-     * Media stream.
+     * Audio media stream.
      */
     MediaStream stream;
     
     /**
-     * Stream index in the media session.
+     * Stream index in the audio media session.
      */
     unsigned    streamIdx;
@@ -1712,8 +1712,8 @@
     
     /**
-     * Notify application when media session is created and before it is
+     * Notify application when audio media session is created and before it is
      * registered to the conference bridge. Application may return different
-     * media port if it has added media processing port to the stream. This
-     * media port then will be added to the conference bridge instead.
+     * audio media port if it has added media processing port to the stream.
+     * This media port then will be added to the conference bridge instead.
      *
      * @param prm	Callback parameter.
@@ -1723,6 +1723,6 @@
     
     /**
-     * Notify application when media session has been unregistered from the
-     * conference bridge and about to be destroyed.
+     * Notify application when audio media session has been unregistered from
+     * the conference bridge and about to be destroyed.
      *
      * @param prm	Callback parameter.